#!/usr/bin/env python3

from random import randint
import unittest

import requests
from testtools import TestCase


SNAP_PROXY = 'snapproxy.launchpad.dev'
SNAP_PROXY_PORT = 3128

SNAP_PROXY_API = 'builderproxyapi.launchpad.dev'
SNAP_PROXY_API_PORT = 8080

TEST_URL = 'http://www.canonical.com'


class TestProxyApiIntegration(TestCase):

    def createToken(self, username):
        token_endpoint = 'http://{url}:{port}/token'.format(
            url=SNAP_PROXY_API, port=SNAP_PROXY_API_PORT)
        payload = {'username': username}
        r = requests.post(token_endpoint, json=payload)
        assert r.status_code == 200
        return r.json()['secret']

    def setUp(self):
        super(TestProxyApiIntegration, self).setUp()
        self.username = 'BUILD-{}'.format(randint(100, 999))
        self.token = self.createToken(self.username)
        self.proxies = {
            'http': 'http://{username}:{password}@{url}:{port}'.format(
                username=self.username,
                password=self.token,
                url=SNAP_PROXY,
                port=SNAP_PROXY_PORT)
            }

    def test_proxy_basic_auth(self):
        r = requests.get(TEST_URL, proxies=self.proxies)
        self.assertEqual(200, r.status_code)


if __name__ == '__main__':
    unittest.main(warnings='ignore')
